// This may look like C code, but it is really -*- C++ -*-

//   Module      : Axiom.h   Version 1.2
//   LastSCCS    : 2/26/92  16:38:32
//   LastEdit    : "Mon Jan 27 13:17:53 1992"
//   Description : 
//   Author      : 
//   Copyright   : GMD Schloss Birlinghoven

#ifndef Axiom_h
#define Axiom_h

class Axiom : public PlayerLocation {
  public:
    Axiom(Player *p_player, int p_shape, int p_color, int p_value, int p_n);
    Axiom(Player *p_player, PlayerLocation *pl, int p_n);
  public:
    GetN()
	{ return n; }
  public:
    void RemoveSelf();
    void AddSelf();
  public:
    virtual char *PrintOn(char *buffer, unsigned int length);
    virtual ostream &DumpOn(ostream &ostr);
  protected:
    int n;
};

DefGenericListWithIterator(AxiomList,Axiom,AxiomListIterator);

#endif
