// This may look like C code, but it is really -*- C++ -*-

//   Module      : GnClassInfo.h   Version 1.3
//   LastSCCS    : 7/29/91  18:05:34
//   LastEdit    : "Thu Jul 25 10:22:04 1991"
//   Description : 
//   Author      : 
//   Copyright   : GMD Schloss Birlinghoven

#ifndef Gnclassinfo_h
#define Gnclassinfo_h

// Store Information about a class in a particular position in the inheritance
// tree.

class GnClass;

class GnClassInfo : public GnObject {
    META_DEF_1(GnClassInfo,GnObject);
    friend class GnClass;
  public:
    GnClassInfo(GnClass *, int);
    GnClass *TheClass()
	{ return the_class; }
    int IsVirtual()
	{ return is_virtual; }
  protected:
    int is_virtual;
    GnClass *the_class;
};

DefGenericListWithIterator(GnClassInfoList,GnClassInfo,GnClassInfoListIterator);

// Store ordering information about a class

class GnClassOrdering : public GnObject {
    META_DEF_1(GnClassOrdering,GnObject);
    friend class GnClass;
  public:
    GnClassOrdering(unsigned int pre);
    GnClassOrdering(unsigned int pre, unsigned int post);
  protected:
    unsigned int post_value;
    unsigned int pre_value;
};

DefGenericListWithIterator(GnClassOrderingList,GnClassOrdering,GnClassOrderingListIterator);

#endif
