/* @(#)GnItem.h	1.10 7/29/91 */

#ifndef Gina_Item_H
#define Gina_Item_H


class GnItem : public GnObject {
    META_DEF_1(GnItem,GnObject);
  public:
    // Constructors
    GnItem(char *name, void *value, Boolean selected = False)
	{ item_name = name; item_value = value; item_selected = selected; };
    GnItem(char *name, Boolean selected = True)
	{ item_name = name; item_value = (void *)name; item_selected=selected;};
    
    // Creators
    char *Name() { return(item_name); };
    void *Value() { return(item_value); };
    Boolean Selected() { return(item_selected); };
    void Selected(Boolean selected) { item_selected = selected; };
  protected:
    char *item_name;
    void *item_value;
    Boolean item_selected;
};

#define GITEM(label, value) (new GnItem(label, (void *)(value)))

#define GITEM_S(label, value) (new GnItem(label, (void *)(value), True))

DefGenericListWithIterator(GnItemList, GnItem, GnItemListIterator);

#endif Gina_Item_H
