/* @(#)GnList.h	1.4 1/29/91 */

#ifndef Gina_List_H
#define Gina_List_H


class GnPushButton;

class GnList : public GnPrimitive {
    META_DEF_1(GnList,GnPrimitive);
  public:
    /* Constructors: */
    GnList () {}

    /* Accessors: */
    //void set_default_action_button( GnPushButton * ) {};
    //GnPushButton *get_default_action_button() { return(0); };

    CALLBACK_DEF(browseSelectionCallback);
    CALLBACK_DEF(defaultActionCallback);
    CALLBACK_DEF(extendedSelectionCallback);
    CALLBACK_DEF(multipleSelectionCallback);
    CALLBACK_DEF(singleSelectionCallback);

    /* Resources (XmList) */

    DEF_SET_GET_I(automaticSelection, Boolean);
    DEF_SET_GET_I(doubleClickInterval, int);
    DEF_SET_GET_I(fontList, XmFontList);
    DEF_SET_GET_I(itemCount, int);
    DEF_SET_GET_I(items, XmStringTable);
    DEF_SET_GET_I(listMarginHeight, Dimension);
    DEF_SET_GET_I(listMarginWidth, Dimension);
    DEF_SET_GET_I(listSizePolicy, unsigned char);
    DEF_SET_GET_I(listSpacing, short);
    DEF_SET_GET_I(scrollBarDisplayPolicy, unsigned char);
    DEF_SET_GET_I(selectedItemCount, int);
    DEF_SET_GET_I(selectedItems, XmStringTable);
    DEF_SET_GET_I(selectionPolicy, unsigned char);
    DEF_SET_GET_I(stringDirection, XmStringDirection);
    DEF_SET_GET_I(topItemPosition, int);
    DEF_SET_GET_I(visibleItemCount, int);

  protected:
    Widget create_widget(GnWidget *, char *);
    //GnPushButton *default_action_button;
};

#endif Gina_List_H
