// This may look like C code, but it is really -*- C++ -*-

//   Module      : GnManager.h   Version 1.12
//   LastSCCS    : 10/24/91  17:30:52
//   LastEdit    : "Tue Oct 22 15:03:54 1991"
//   Description : 
//   Author      : 
//   Copyright   : GMD Schloss Birlinghoven

#ifndef _Gina_Manager_H_
#define _Gina_Manager_H_

class GnManager : public GnConstraint {
    META_DEF_1(GnManager,GnConstraint);
  public:
    GnManager() {}

    CALLBACK_DEF(helpCallback);
    
    DEF_SET_GET_I(bottomShadowColor, Pixel);
    DEF_PIXMAP(bottomShadowPixmap);
    DEF_SET_GET_I(foreground, Pixel);
    DEF_SET_GET_I(highlightColor, Pixel);
    DEF_PIXMAP(highlightPixmap);
    DEF_SET_GET_I(navigationType,unsigned char);
    DEF_SET_GET_I(shadowThickness, short);
    DEF_SET_GET_I(topShadowColor, Pixel);
    DEF_PIXMAP(topShadowPixmap);
    DEF_SET_GET_I(traversalOn, Boolean);
    DEF_SET_GET_I(unitType, unsigned char);
    DEF_SET_GET_I(userData, caddr_t);
  protected:
    Widget create_widget(GnWidget *, char *);
};

#endif _Gina_Manager_H_
