/* @(#)GnRowColumn.h	1.5 2/25/91 */

#ifndef Gina_Row_Column_H
#define Gina_Row_Column_H


class GnPulldownMenuPane;
class GnCascadeButton;
class GnLabel;

class GnRowColumn : public GnManager {
    META_DEF_1(GnRowColumn,GnManager);
  public:
    GnRowColumn();

    /* Callbacks */

    CALLBACK_DEF(entryCallback);
    CALLBACK_DEF(mapCallback);
    CALLBACK_DEF(unmapCallback);

    /* Resources */

    void setR_label_string(char *);

    DEF_SET_GET_I(adjustLast, Boolean);
    DEF_SET_GET_I(adjustMargin, Boolean);
    DEF_SET_GET_I(entryAlignment, unsigned char);
    DEF_SET_GET_I(entryBorder, short);
    DEF_SET_GET_I(entryClass, WidgetClass);
    DEF_SET_GET_I(isAligned, Boolean);
    DEF_SET_GET_I(isHomogeneous, Boolean);
    DEF_XMSTRING(labelString);
    DEF_SET_GET_I(marginHeight, Dimension);
    DEF_SET_GET_I(marginWidth, Dimension);
    DEF_SET_GET_I(menuAccelerator, char *);
    WIDGET_RESOURCE_DEF(menuHelpWidget, GnCascadeButton);
    WIDGET_RESOURCE_DEF(menuHistory, GnLabel);
    DEF_SET_GET_I(mnemonic, char);
    DEF_SET_GET_I(numColumns, short);
    DEF_SET_GET_I(orientation, unsigned char);
    DEF_SET_GET_I(packing, unsigned char);
    DEF_SET_GET_I(popupEnabled, Boolean);
    DEF_SET_GET_I(radioAlwaysOne, Boolean);
    DEF_SET_GET_I(radioBehavior, Boolean);
    DEF_SET_GET_I(resizeHeight, Boolean);
    DEF_SET_GET_I(resizeWidth, Boolean);
    DEF_SET_GET_I(rowColumnType, unsigned char);
    DEF_SET_GET_I(shadowThickness, int);
    DEF_SET_GET_I(spacing, short);
    WIDGET_RESOURCE_DEF(subMenuId, GnPulldownMenuPane);
    DEF_SET_GET_I(whichButton, unsigned int);

  protected:
    Widget create_widget(GnWidget *, char *);
};

#endif Gina_Row_Column_H
