/* @(#)GnToolkit.h	1.11 7/29/91 */

// This #ifdef should not be changed because GnWidget.h relies on it
#ifndef G_Toolkit_H
#define G_Toolkit_H

#ifndef SABER_____
#endif SABER_____


class GnToolkit : public GnObject {
    META_DEF_1(GnToolkit,GnObject);
    friend class GnWidget;
  public:
    GnToolkit(char *application_class = 0, char *application_name = 0);

    Boolean AppInitialize(Cardinal *argc, char **argv,
			  Boolean abort_on_error = True);
    void AppMainLoop();
    char *AppClass()
	{ return(app_class); };
    char *AppName()
	{ return(app_name); };
    Display *AppDisplay()
	{ return(display); };
    XtAppContext AppContext()
	{ return(app_context); };
    GnApplicationShell &AppShell()
 	{ return(app_shell); };
    
    virtual XmStringCharSet AppCharSet()
	{ return (XmStringCharSet)XmSTRING_DEFAULT_CHARSET; };
    virtual XmStringDirection AppStringDirection()
	{ return XmSTRING_DIRECTION_DEFAULT; };

    XtErrorHandler set_xt_error_handler(XtErrorHandler);
    XtErrorHandler set_xt_warning_handler(XtErrorHandler);
    XErrorHandler set_x_error_handler(XErrorHandler);

    int get_uid()
	{return uid;};
    int get_euid()
	{return euid;};
    int get_gid()
	{return gid;};
    int get_egid()
	{return egid;};
  private:
    Display           *display;
    XtAppContext       app_context;
    char              *app_class;
    char              *app_name;
    GnApplicationShell  app_shell;
    GnWidgetTable       widget_table;
    int                uid, euid, gid, egid;
};

inline char *XMSTRING_GET_LTOR(XmString s )
    { char *st; XmStringGetLtoR(s, GnWidget::TheToolkit()->AppCharSet(), &st);
      return st; }

#endif G_Toolkit_H








