// This may look like C code, but it is really -*- C++ -*-

//   Module      : GnTest.C   Version 1.9
//   LastSCCS    : 1/23/92  12:32:59
//   LastEdit    : "Mon Jan 20 11:26:06 1992"
//   Description : 
//   Author      : 
//   Copyright   : GMD Schloss Birlinghoven

#include <Gina/GnBasic.h>

class GnLeft : public virtual GnObject {
    META_DEF_1_V(GnLeft,GnObject);
  public:
    GnLeft() {}
  protected:
    int i;
};

class GnRight : public virtual GnObject {
    META_DEF_1_V(GnRight,GnObject);
  public:
    GnRight() {}
  protected:
    int j;
};

META_IMPL_1_V(GnRight,GnObject,)

META_IMPL_1_V(GnLeft,GnObject,)

class GnMultiple : public GnLeft, virtual public GnRight {
    META_DEF_2_NV(GnMultiple,GnLeft,GnRight);
  public:
    GnMultiple() {}
  protected:
    int k;
};

META_IMPL_2_NV(GnMultiple,GnLeft,GnRight,);

class GnMultipleSub : public GnMultiple {
    META_DEF_1(GnMultipleSub,GnMultiple);
  public:
    GnMultipleSub() {}
  protected:
    int l;
};

META_IMPL_1(GnMultipleSub,GnMultiple,);

int main(unsigned int, char *[])
{
    GnClass::Initialize();
    
    GnPathname *pn = new GnPathname;

    GnObjectList *olist = new GnObjectList;
    GnObjectListIterator *oit = new GnObjectListIterator(olist);

    GnString *str = new GnString("Andreas Baecker");
    GnInteger *gint = new GnInteger(12345678);
    GnFloat *gfloat = new GnFloat(3.1415279);
    GnIntegerItem *intitem = new GnIntegerItem("Andreas Baecker", 29);
    GnFloatItem *fitem = new GnFloatItem("Andreas Baecker", 29.5);

    GnMultipleSub *msub = new GnMultipleSub();
    
    GnClassListIterator *class_it = GnClass::ClassListIterator();

    cerr << endl << "List of classes in the system:\n";
    for( class_it->Start(); ! class_it->Off(); class_it->Forth() ) {
	cerr << "    "       << class_it->Item()->Name() << ":";
	cerr << class_it->Item()->Size() << " Bytes, ";
	cerr << endl;
    }
    delete class_it;

}
    
