// This may look like C code, but it is really -*- C++ -*-

//   Module      : ClearAll.C   Version 1.2
//   LastSCCS    : 2/26/92  16:36:47
//   LastEdit    : "Fri Feb 21 14:29:33 1992"
//   Description : 
//   Author      : 
//   Copyright   : GMD Schloss Birlinghoven

ClearAll ::
ClearAll( GnDocument *doc )
: GnCommand( doc )
{
}

void ClearAll ::
doit()
{
    GnViewObjectIterator it(document->get_main_view()->get_view_objects());

    for( it.Start(); ! it.Off(); it.Forth() ) {
	objects.Append(it.Item());
	it.Item()->deinstall();
    }
}

void ClearAll ::
undoit()
{
    for(GnViewObjectIterator it(objects); ! it.Off(); it.Forth() )
	it.Item()->install(document->get_main_view(),
			   it.Item()->get_x_pos(), it.Item()->get_y_pos() );
}

void ClearAll ::
redoit()
{
    for(GnViewObjectIterator it(objects); ! it.Off(); it.Forth() )
        it.Item()->deinstall();
}
