// This may look like C code, but it is really -*- C++ -*-

//   Module      : Card.C   Version 1.2
//   LastSCCS    : 2/26/92  16:37:48
//   LastEdit    : "Fri Nov  8 13:40:43 1991"
//   Description : 
//   Author      : 
//   Copyright   : GMD Schloss Birlinghoven

Card::
Card(int p_shape, int p_color, int p_value)
: PlayerLocation(0, p_shape, p_color, p_value)
{
    REQUIRE(p_shape >= 0 && p_shape <= 2, "Shape is 0, 1, or 2");
    REQUIRE(p_color >= 0 && p_color <= 3, "Color is 0, 1, 2, or 3");
    REQUIRE(p_value >= 0 && p_value <= 2, "Value is 0, 1, or 2");
}

void Card::
SetPlayer(Player *p_player)
{
    player = p_player;
}

ImplGenericListWithIterator(CardList,CardListIterator);

