;; @(#)c++-member.el	1.2 2/19/92

;; Binds functions to F2 and F3 keys on sun keyboards.
;; Requires (load "sun-fkeys") !!!!!!
;;
;; (define-key sun-raw-map "225z" 'new-c++-member-variable-inline)     ;; F2
;; (define-key sun-raw-map "226z" 'new-c++-member-variable-outline)    ;; F3

(defun c++-upper-case (mv-name)
  (setq pos 0)
  (setq upper-case-mv-name "")
  (setq was-underscore t)
  (setq s-length (length mv-name))
  (while (< pos s-length)
    (if (= (aref mv-name pos) ?_)
	(setq was-underscore t)
      (if (not was-underscore)
	  (setq upper-case-mv-name
		(concat upper-case-mv-name (char-to-string (aref mv-name pos))))
	(setq upper-case-mv-name
	      (concat upper-case-mv-name (char-to-string
					  (upcase (aref mv-name pos)))))
	(setq was-underscore nil)))
    (setq pos (1+ pos)))
  upper-case-mv-name)

(defun new-c++-member-variable-inline (mv-name mv-type)
  (interactive "sName: \nsType: ")
  (beginning-of-line)
  (setq mv-name-upper (c++-upper-case mv-name))
  (setq mv-type-string (concat mv-type (if (string-equal
					    "*" (substring mv-type -1 nil))
					   "" " ")))
  (setq mv-name-arg (concat "p_" mv-name))
  (insert "  private:\n"
	  "    " mv-type-string mv-name ";\n"
	  "  public:\n"
	  "    void Set" mv-name-upper "(" mv-type-string mv-name-arg ")\n"
	  "        { " mv-name " = " mv-name-arg "; }\n"
	  "    " mv-type-string "Get" mv-name-upper "()\n"
	  "        { return " mv-name "; }\n")
  t)
  
(defun new-c++-member-variable-outline (mv-name mv-type mv-class)
  (interactive "sName: \nsType: \nsClass: ")
  (beginning-of-line)
  (setq mv-name-upper (c++-upper-case mv-name))
  (setq mv-type-string (concat mv-type (if (string-equal
					    "*" (substring mv-type -1 nil))
					   "" " ")))
  (setq mv-name-arg (concat "p_" mv-name))
  (insert "  private:\n"
	  "    " mv-type-string mv-name ";\n"
	  "  public:\n"
	  "    void Set" mv-name-upper "(" mv-type-string mv-name-arg ");\n"
	  "    " mv-type-string "Get" mv-name-upper "();\n")
  (insert "void " mv-class "::\n"
	  "Set" mv-name-upper "(" mv-type-string mv-name-arg ")\n"
	  "{\n"
	  "    " mv-name " = " mv-name-arg ";\n"
	  "}\n\n"
	  mv-type-string mv-class "::\n"
	  "Get" mv-name-upper "()\n"
	  "{\n"
	  "    return " mv-name ";\n"
	  "}\n")
  t)
