/* @(#)GnDebug.h	1.19 1/14/92 */

#ifndef Gina_Debug_H
#define Gina_Debug_H

#ifdef GINA_DEBUG

#define Gina_Debug_NL(p)              Gina_Debug_Proc_NL (p)
#define Gina_Debug(p)                 Gina_Debug_Proc (p)

inline void Gina_Debug_Proc_NL(char p)   { cerr << p << endl; }
inline void Gina_Debug_Proc_NL(short p)  { cerr << p << endl; }
inline void Gina_Debug_Proc_NL(int p)    { cerr << p << endl; }
inline void Gina_Debug_Proc_NL(long p)   { cerr << p << endl; }
inline void Gina_Debug_Proc_NL(unsigned short p)  { cerr << p << endl; }
inline void Gina_Debug_Proc_NL(unsigned int p)    { cerr << p << endl; }
inline void Gina_Debug_Proc_NL(unsigned long p)   { cerr << p << endl; }
inline void Gina_Debug_Proc_NL(float p)  { cerr << p << endl; }
inline void Gina_Debug_Proc_NL(double p) { cerr << p << endl; }
inline void Gina_Debug_Proc_NL(char *p)  { cerr << p << endl; }
inline void Gina_Debug_Proc_NL(void *p)  { cerr << "(void*)" << p << endl; }

inline void Gina_Debug_Proc(char p)   { cerr << p; }
inline void Gina_Debug_Proc(short p)  { cerr << p; }
inline void Gina_Debug_Proc(int p)    { cerr << p; }
inline void Gina_Debug_Proc(long p)   { cerr << p; }
inline void Gina_Debug_Proc(unsigned short p)  { cerr << p; }
inline void Gina_Debug_Proc(unsigned int p)    { cerr << p; }
inline void Gina_Debug_Proc(unsigned long p)   { cerr << p; }
inline void Gina_Debug_Proc(float p)  { cerr << p; }
inline void Gina_Debug_Proc(double p) { cerr << p; }
inline void Gina_Debug_Proc(char *p)  { cerr << p; }
inline void Gina_Debug_Proc(void *p)  { cerr << "(void*)" << p; }

#else

#define Gina_Debug_NL(p)
#define Gina_Debug(p)

#endif GINA_DEBUG

#endif Gina_Debug_H
