// This may look like C code, but it is really -*- C++ -*-

//   Module      : GnMainMenu.h   Version 1.17
//   LastSCCS    : 10/24/91  17:30:49
//   LastEdit    : "Thu Oct 24 16:00:37 1991"
//   Description : 
//   Author      : Robert Babatz and Andreas Baecker
//   Copyright   : GMD Schloss Birlinghoven

#ifndef Gina_Main_Menu_H
#define Gina_Main_Menu_H


class GnMainMenu : public GnMenuBar {
    META_DEF_1(GnMainMenu,GnMenuBar);
  public:
    GnMainMenu() {}

    GnMenuEntry *add_menu_command(char *topic_name, char *topic_label,
				 char *item_name, char *item_label,
				 GnCallback *callback, Boolean sens = True);
    GnMenuEntry *add_menu_command(char *topic_name, char *item_name,
				  GnCallback *callback, Boolean sens = True);
  protected:
    GnMenuTopic *find_topic(char *topic_name );
    GnMenuTopic *add_topic( char *topic_name, char *topic_label);
    void remove_menu_entry(char *topic_name, char *item_name,
			   GnMenuEntry *entry );
  private:
    GnMenuTopicList topics;
};

#endif Gina_Main_Menu_H
