/* @(#)GnText.h	1.5 2/27/91 */

#ifndef Gina_Text_H
#define Gina_Text_H


class GnText : public GnPrimitive {
    META_DEF_1(GnText,GnPrimitive);
  public:
    GnText() {}

    /* Methods: */
    void set_string (char *);
    char * get_string ();

    /* Callbacks */
    CALLBACK_DEF(activateCallback);
    CALLBACK_DEF(focusCallback);
    CALLBACK_DEF(valueChangedCallback);
    CALLBACK_DEF(losingFocusCallback);
    CALLBACK_DEF(modifyVerifyCallback);
    CALLBACK_DEF(motionVerifyCallback);

    /* Resources */
    DEF_SET_GET_I(autoShowCursorPosition, Boolean);
    DEF_SET_GET_I(cursorPosition, XmTextPosition);
    DEF_SET_GET_I(editable, Boolean);    
    DEF_SET_GET_I(editMode, int);    
    DEF_SET_GET_I(marginHeight, short);    
    DEF_SET_GET_I(marginWidth, short);  
    DEF_SET_GET_I(maxLength, int);   
    DEF_SET_GET_I(topPosition, XmTextPosition);
    DEF_SET_GET_I(value, char *);
    
    /* Resources (XmText Input) */
    DEF_SET_GET_I(pendingDelete, Boolean);
    DEF_SET_GET_I(selectThreshold, int);

    /* Resources (XmText Ouput) */
    DEF_SET_GET_I(blinkRate, int);
    DEF_SET_GET_I(columns, short);
    DEF_SET_GET_I(cursorPositionVisible, Boolean);
    DEF_SET_GET_I(resizeHeight, Boolean);
    DEF_SET_GET_I(resizeWidth, Boolean);
    DEF_SET_GET_I(rows, short);
    DEF_SET_GET_I(wordWrap, Boolean);

  protected:
    Widget create_widget(GnWidget *, char *);
};

#endif Gina_Text_H
