/* "@(#)GnMessageBox.C	1.11 2/25/91" */


extern "C" {
extern Widget XmCreateMessageBox(Widget, char *, Arg *, int);
extern Widget XmMessageBoxGetChild(Widget, ...);
}

META_IMPL_1(GnMessageBox,GnBulletinBoard,);

GnMessageBox::GnMessageBox()
{
    ok_button = help_button = 0;
}

Widget GnMessageBox ::
create_widget(GnWidget *par, char * widget_name)
{
    return(XmCreateMessageBox(par->get_widget_id_for_sons(), widget_name,
			      args, args_n));
}

GnPushButton *GnMessageBox::
getR_helpButton()
{
    Widget button;

    if( ! help_button ) {
	button = XmMessageBoxGetChild(widget_id, XmDIALOG_HELP_BUTTON);
	help_button = new GnPushButton;
	help_button->encapsulate_self(button);
    }
    return(help_button);
}

GnPushButton *GnMessageBox::
getR_okButton()
{
    Widget button;

    if( !ok_button ) {
	button = XmMessageBoxGetChild(widget_id, XmDIALOG_OK_BUTTON);
	ok_button = new GnPushButton;
	ok_button->encapsulate_self(button);
    }
    return(ok_button);
}
