// This may look like C code, but it is really -*- C++ -*-

//   Module      : GnShell.C   Version 1.19
//   LastSCCS    : 1/14/92  15:18:13
//   LastEdit    : "Mon Jan 13 09:30:05 1992"
//   Description : 
//   Author      : 
//   Copyright   : GMD Schloss Birlinghoven


META_IMPL_1(GnShell,GnComposite,);

GnShell::
GnShell()
{
}

void GnShell::
Popup(XtGrabKind p_grab_kind)
{
    XtRealizeWidget(get_group_widget_id());
    XtPopup(get_group_widget_id(), p_grab_kind);
}

void GnShell::
Popdown()
{
    XtPopdown(get_group_widget_id());
}

META_IMPL_1(GnWMShell,GnShell,);

GnWMShell::GnWMShell()
{
}

META_IMPL_1(GnVendorShell,GnWMShell,);

GnVendorShell::GnVendorShell()
{
}

void GnVendorShell::
add_wm_closed_callback(GnCallback *callback)
{
    add_protocol_callback(callback,
			  XmInternAtom(TheToolkit()->AppDisplay(),
				       "WM_PROTOCOLS", False),
			  XmInternAtom(TheToolkit()->AppDisplay(),
				       "WM_DELETE_WINDOW", False));
}

void GnVendorShell::
add_protocol_callback(GnCallback *callback, Atom property, Atom protocol)
{
    setR_deleteResponse(XmDO_NOTHING);
    if( IsMotifWidgetCreated() )
	SetValues();
    callback->attach_to_widget(get_group_widget_id(), property, protocol);
}

META_IMPL_1(GnTransientShell,GnVendorShell,);

GnTransientShell::GnTransientShell()
{
}

META_IMPL_1(GnOverrideShell,GnShell,);

GnOverrideShell::GnOverrideShell()
{
}

Widget GnShell::create_widget(GnWidget *, char *)
{
    return(0);
}

Widget GnWMShell::create_widget(GnWidget *, char *)
{
    return(0);
}

Widget GnVendorShell::create_widget(GnWidget *, char *)
{
    return(0);
}

Widget GnTransientShell::create_widget(GnWidget *, char *)
{
    return(0);
}

Widget GnOverrideShell::create_widget(GnWidget *, char *)
{
    return(0);
}
